#include "rusinluk_dip_incl.h"

CWinEdge::CWinEdge(CWin *a, CWin *b) :
	cwinA(a),
	cwinB(b)
{
}

CWin *CWinEdge::getCWinA() const {
	return cwinA;
}

CWin *CWinEdge::getCWinB() const {
	return cwinB;
}

CWin *CWinEdge::adr(const CWin *x) const {
	if (x == cwinA) {
		return cwinB;
	}
	if (x == cwinB) {
		return cwinA;
	}
	return NULL;
}

void CWinEdge::setEval(const Params &pm, const TrieStor<int> &primOuts, TrieStor<CWin *> &neighbors,
	TrieStor<int> &workIns, TrieStor<int> &workOuts, TrieStor<int> &workIsect
) {
	cwinA->mergeIO(cwinB, primOuts, neighbors, workIns, workOuts, workIsect);
	int gatesN = cwinA->getGateN() + cwinB->getGateN();
	eval =
		workIns.size() * pm.wgCwinI +
		workOuts.size() * pm.wgCwinO +
		gatesN * pm.wgCwinG;
}
