#include "rusinluk_dip_incl.h"

MyRand::MyRand() {
	seedT();
}

MyRand::MyRand(unsigned int a, unsigned int b) {
	seed(a, b);
}

unsigned int MyRand::get() const {
	return (hi << 16) + lo;
}

double MyRand::getD() const {
	return get() / exp(log(256) * sizeof(unsigned int));
}

unsigned int MyRand::next() {
	hi = 36969 * (hi & 0xffff) + (hi >> 16);
	lo = 18000 * (lo & 0xffff) + (lo >> 16);
	return get();
}

double MyRand::nextD() {
	next();
	return getD();
}

void MyRand::nextName(string &s, int n) {
	s = "";
	int m = 'z' - 'a' + 1;
	for (int i = 0; i < n; i++) {
		s += (char)('a' + next() % m);
	}
}

void MyRand::seed(unsigned int a, unsigned int b) {
	hi = (a ? a : 3716960521u);
	lo = (b ? b : 2174103536u);
}

void MyRand::seedT() {
	time_t s = time(NULL);
	seed((s >> 16) & 0xffff, s & 0xffff);
}
