class __attribute__((packed)) Storable {
private:
	void *buf; // for load/save operations
	int bufN;
public:
	Storable(int bufN);
	virtual ~Storable();
	void *getBuf() const;
	int getBufN() const;
	void load();
	void send(int dest, int tag);
	void recv(int src, int tag, MPI_Status &);
	void rmaPut(SharedMem &);
	void rmaGet(SharedMem &);
	virtual void save() = 0;
private:
	void allocBuf(int bufN);
	void allocBuf_0(int bufN); // without pointer set
	void recv_0(int src, int tag, MPI_Status &);
	void rmaGet_0(SharedMem &);
	virtual void setPtrs() = 0; // set/restore child's pointers to the buffer
	virtual void load_0() = 0;
};
