#ifndef RUSINLUK_DIP_INCL_GUARD
#define RUSINLUK_DIP_INCL_GUARD

#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <string>
#include <sstream>
#include <vector>
#include <ctime>
#include <cmath>
#include <climits>
#include <limits>
#include <typeinfo>

#include "mpi.h"

using namespace std;

class Circuit;
class CWin;
class CWinEdge;
class Gate;
class Heap;
class Heapable;
class LevItem;
class Mutex;
class MyRand;
class Params;
class Resynth;
class RWork;
class __attribute__((packed)) Scheduler;
class SharedMem;
class __attribute__((packed)) Storable;
template<typename T> class TrieStor;

#include "rusinluk_dip_defs.h"
#include "rusinluk_dip_prims.h"
#include "rusinluk_dip_Params.h"
#include "rusinluk_dip_MyRand.h"
#include "rusinluk_dip_SharedMem.h"
#include "rusinluk_dip_Mutex.h"
#include "rusinluk_dip_TrieStor.h"
#include "rusinluk_dip_Heapable.h"
#include "rusinluk_dip_Heap.h"
#include "rusinluk_dip_Gate.h"
#include "rusinluk_dip_CWin.h"
#include "rusinluk_dip_CWinEdge.h"
#include "rusinluk_dip_Circuit.h"
#include "rusinluk_dip_Storable.h"
#include "rusinluk_dip_RWork.h"
#include "rusinluk_dip_Scheduler.h"
#include "rusinluk_dip_Resynth.h"

string toString(double);

void logMe(string, bool endL);
void logRow(string);
void logErr(string);
void logErr(string errT, string errS);
void logTime(string msg, double time0);

void parseNames(const string &, vector<string> &res);
bool replaceStr(string &s, const string &s0, const string &s1, int occurI); /* replaces s0 with s1 in s
	- occurI-th occurence, negative => from end, zero => all */
void fileSuffix(string &file, string x); // before the last dot, at the end otherwise

void fileTest(const string &file);
void ifsOpen(ifstream &, const string &file, ios_base::openmode);
void ofsOpen(ofstream &, const string &file, ios_base::openmode);
void ifsOpenWait(ifstream &, const string &file, ios_base::openmode, double t, double coef); // for collective reading
void fileCopy(const string &fileI, const string &fileO);

bool getFLine(ifstream &, string &);
bool getBlifLine(ifstream &, string &); // merges backslashed lines, removes a comment

int mpiProcN();
int mpiRank();
void mpiAbort();
void mpiDelay(double t); // in seconds
void waitPhase(double t); // waiting based on rank
void mpiBarrier();

template<typename T, typename Q> Q *dynCast(T *);

#endif
